// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    PaginierungDTO,
    PhasenvorlageEntityDTO,
    RegelungsvorhabenTypType,
    TerminvorlageEntityDTO,
    ZeitplanungKommentarCreateRequestDTO,
    ZeitplanungKommentarModifyRequestDTO,
    ZeitplanungsvorlageEntityListResponseShortDTO,
    ZeitplanungsvorlageEntityResponseDTO,
    ZeitplanungsvorlageEntityResponseShortDTO,
    ZeitplanungsvorlageEntityShortDTO,
    ZeitplanungsvorlageKommentarEntityListResponseDTO,
    ZeitplanungsvorlageTableDTOs,
    ZeitplanungsvorlagenelementEntityDTO,
    ZeitvorlagevorlagenBauplanDTO,
} from '../models';

export interface AddDateToZeitplanungsvorlageRequest {
    id: string;
    terminvorlageEntityDTO: TerminvorlageEntityDTO;
}

export interface AddPhaseToZeitplanungsvorlageRequest {
    id: string;
    phasenvorlageEntityDTO: PhasenvorlageEntityDTO;
}

export interface ArchiveZeitplanungsvorlageRequest {
    id: string;
}

export interface CreateZeitplanungsvorlageRequest {
    zeitplanungsvorlageEntityShortDTO: ZeitplanungsvorlageEntityShortDTO;
}

export interface CreateZpvKommentarRequest {
    zeitplanungsvorlageId: string;
    zeitplanungKommentarCreateRequestDTO: ZeitplanungKommentarCreateRequestDTO;
}

export interface DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageRequest {
    elementId: string;
}

export interface DeleteZpvKommentarRequest {
    kommentarId: string;
}

export interface GetBauplaeneForVorhabenartRequest {
    vorhabenart: RegelungsvorhabenTypType;
}

export interface GetDefaultZeitplanungsvorlageByIdRequest {
    id: string;
}

export interface GetDefaultZeitplanungsvorlagenForTableViewRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetZeitplanungsvorlageRequest {
    id: string;
}

export interface GetZeitplanungsvorlagenForTableViewRequest {
    isFilterNeeded: boolean;
    paginierungDTO: PaginierungDTO;
}

export interface GetZpvKommentareRequest {
    zeitplanungsvorlageId: string;
}

export interface ModifyDateInZeitplanungsvorlageRequest {
    elementId: string;
    terminvorlageEntityDTO: TerminvorlageEntityDTO;
}

export interface ModifyPhaseInZeitplanungsvorlageRequest {
    elementId: string;
    phasenvorlageEntityDTO: PhasenvorlageEntityDTO;
}

export interface ModifyZpvKommentarRequest {
    kommentarId: string;
    zeitplanungKommentarModifyRequestDTO: ZeitplanungKommentarModifyRequestDTO;
}

/**
 * no description
 */
export class ZeitplanungsvorlageControllerApi extends BaseAPI {

    /**
     * Fügt einer Zeitplanungsvorlage einen neuen Termin hinzu
     * POST ZEITPLANUNGSVORLAGE DATE
     */
    addDateToZeitplanungsvorlage({ id, terminvorlageEntityDTO }: AddDateToZeitplanungsvorlageRequest): Observable<void>
    addDateToZeitplanungsvorlage({ id, terminvorlageEntityDTO }: AddDateToZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addDateToZeitplanungsvorlage({ id, terminvorlageEntityDTO }: AddDateToZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addDateToZeitplanungsvorlage');
        throwIfNullOrUndefined(terminvorlageEntityDTO, 'terminvorlageEntityDTO', 'addDateToZeitplanungsvorlage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/{id}/date'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: terminvorlageEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Fügt einer Zeitplanungsvorlage eine neue Phase hinzu
     * POST ZEITPLANUNGSVORLAGE PHASE
     */
    addPhaseToZeitplanungsvorlage({ id, phasenvorlageEntityDTO }: AddPhaseToZeitplanungsvorlageRequest): Observable<void>
    addPhaseToZeitplanungsvorlage({ id, phasenvorlageEntityDTO }: AddPhaseToZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addPhaseToZeitplanungsvorlage({ id, phasenvorlageEntityDTO }: AddPhaseToZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addPhaseToZeitplanungsvorlage');
        throwIfNullOrUndefined(phasenvorlageEntityDTO, 'phasenvorlageEntityDTO', 'addPhaseToZeitplanungsvorlage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/{id}/phase'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: phasenvorlageEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Archiviert eine Zeitplanungsvorlage
     * Zeitplanungsvorlage archivieren (E+T)
     */
    archiveZeitplanungsvorlage({ id }: ArchiveZeitplanungsvorlageRequest): Observable<void>
    archiveZeitplanungsvorlage({ id }: ArchiveZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveZeitplanungsvorlage({ id }: ArchiveZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'archiveZeitplanungsvorlage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/{id}/archivieren'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine neue Zeitplanungsvorlage an
     * POST ZEITPLANUNGSVORLAGE
     */
    createZeitplanungsvorlage({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlageRequest): Observable<ZeitplanungsvorlageEntityResponseShortDTO>
    createZeitplanungsvorlage({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseShortDTO>>
    createZeitplanungsvorlage({ zeitplanungsvorlageEntityShortDTO }: CreateZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseShortDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseShortDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlageEntityShortDTO, 'zeitplanungsvorlageEntityShortDTO', 'createZeitplanungsvorlage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseShortDTO>({
            url: '/zeitplanungsvorlage',
            method: 'POST',
            headers,
            body: zeitplanungsvorlageEntityShortDTO,
        }, opts?.responseOpts);
    };

    /**
     * Legt einen Kommentar an
     * POST KOMMENTAR
     */
    createZpvKommentar({ zeitplanungsvorlageId, zeitplanungKommentarCreateRequestDTO }: CreateZpvKommentarRequest): Observable<void>
    createZpvKommentar({ zeitplanungsvorlageId, zeitplanungKommentarCreateRequestDTO }: CreateZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createZpvKommentar({ zeitplanungsvorlageId, zeitplanungKommentarCreateRequestDTO }: CreateZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(zeitplanungsvorlageId, 'zeitplanungsvorlageId', 'createZpvKommentar');
        throwIfNullOrUndefined(zeitplanungKommentarCreateRequestDTO, 'zeitplanungKommentarCreateRequestDTO', 'createZpvKommentar');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/kommentar/{zeitplanungsvorlageId}'.replace('{zeitplanungsvorlageId}', encodeURI(zeitplanungsvorlageId)),
            method: 'POST',
            headers,
            body: zeitplanungKommentarCreateRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht eine Phase oder einen Termin aus der Zeitplanungsvorlage
     * DELETE ZEITPLANUNGSVORLAGE PHASE/DATE
     */
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlage({ elementId }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageRequest): Observable<void>
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlage({ elementId }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlage({ elementId }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'deleteZeitplanungsvorlagenelementFromZeitplanungsvorlage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/element/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht einen Kommentar
     * DELETE KOMMENTAR
     */
    deleteZpvKommentar({ kommentarId }: DeleteZpvKommentarRequest): Observable<void>
    deleteZpvKommentar({ kommentarId }: DeleteZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteZpvKommentar({ kommentarId }: DeleteZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(kommentarId, 'kommentarId', 'deleteZpvKommentar');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/kommentar/{kommentarId}'.replace('{kommentarId}', encodeURI(kommentarId)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Liste von Systemvorlagen für Phasen/Terminen zu einer Vorhabenart
     * GET ZEITPLANUNGSVORLAGE PHASES/DATES TEMPLATES
     */
    getBauplaeneForVorhabenart({ vorhabenart }: GetBauplaeneForVorhabenartRequest): Observable<Array<ZeitvorlagevorlagenBauplanDTO>>
    getBauplaeneForVorhabenart({ vorhabenart }: GetBauplaeneForVorhabenartRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<ZeitvorlagevorlagenBauplanDTO>>>
    getBauplaeneForVorhabenart({ vorhabenart }: GetBauplaeneForVorhabenartRequest, opts?: OperationOpts): Observable<Array<ZeitvorlagevorlagenBauplanDTO> | AjaxResponse<Array<ZeitvorlagevorlagenBauplanDTO>>> {
        throwIfNullOrUndefined(vorhabenart, 'vorhabenart', 'getBauplaeneForVorhabenart');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<ZeitvorlagevorlagenBauplanDTO>>({
            url: '/zeitplanungsvorlage/bauplaene/{vorhabenart}'.replace('{vorhabenart}', encodeURI(vorhabenart)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Zeitplanungsvorlage
     * GET ZEITPLANUNGSVORLAGE
     */
    getDefaultZeitplanungsvorlageById({ id }: GetDefaultZeitplanungsvorlageByIdRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    getDefaultZeitplanungsvorlageById({ id }: GetDefaultZeitplanungsvorlageByIdRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    getDefaultZeitplanungsvorlageById({ id }: GetDefaultZeitplanungsvorlageByIdRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getDefaultZeitplanungsvorlageById');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage/default/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der DEFAULT Zeitplanungsvorlagen für die Tabellenansicht ab (»Zeitplanungsvorlagen«)
     * GET DEFAULT ZEITPLANUNGSVORLAGEN LIST FOR TABLEVIEW
     */
    getDefaultZeitplanungsvorlagenForTableView({ paginierungDTO }: GetDefaultZeitplanungsvorlagenForTableViewRequest): Observable<ZeitplanungsvorlageTableDTOs>
    getDefaultZeitplanungsvorlagenForTableView({ paginierungDTO }: GetDefaultZeitplanungsvorlagenForTableViewRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageTableDTOs>>
    getDefaultZeitplanungsvorlagenForTableView({ paginierungDTO }: GetDefaultZeitplanungsvorlagenForTableViewRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageTableDTOs | AjaxResponse<ZeitplanungsvorlageTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getDefaultZeitplanungsvorlagenForTableView');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageTableDTOs>({
            url: '/zeitplanungsvorlage/zeitplanungsvorlagen/default/tabellenansicht',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine default Zeitplanungsvorlage
     * GET DEFAULT ZEITPLANUNGSVORLAGE
     */
    getZeitplanungsvorlage({ id }: GetZeitplanungsvorlageRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    getZeitplanungsvorlage({ id }: GetZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    getZeitplanungsvorlage({ id }: GetZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getZeitplanungsvorlage');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zeitplanungsvorlagen des Anwenders ab (»Zeitplanungsvorlagen«)
     * GET ZEITPLANUNGSVORLAGEN LIST FOR USER
     */
    getZeitplanungsvorlagen(): Observable<ZeitplanungsvorlageEntityListResponseShortDTO>
    getZeitplanungsvorlagen(opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityListResponseShortDTO>>
    getZeitplanungsvorlagen(opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityListResponseShortDTO | AjaxResponse<ZeitplanungsvorlageEntityListResponseShortDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityListResponseShortDTO>({
            url: '/zeitplanungsvorlage/zeitplanungsvorlagen',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zeitplanungsvorlagen des Anwenders für die Tabellenansicht ab (»Zeitplanungsvorlagen«)
     * GET ZEITPLANUNGSVORLAGEN LIST FOR USERS TABLEVIEW
     */
    getZeitplanungsvorlagenForTableView({ isFilterNeeded, paginierungDTO }: GetZeitplanungsvorlagenForTableViewRequest): Observable<ZeitplanungsvorlageTableDTOs>
    getZeitplanungsvorlagenForTableView({ isFilterNeeded, paginierungDTO }: GetZeitplanungsvorlagenForTableViewRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageTableDTOs>>
    getZeitplanungsvorlagenForTableView({ isFilterNeeded, paginierungDTO }: GetZeitplanungsvorlagenForTableViewRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageTableDTOs | AjaxResponse<ZeitplanungsvorlageTableDTOs>> {
        throwIfNullOrUndefined(isFilterNeeded, 'isFilterNeeded', 'getZeitplanungsvorlagenForTableView');
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getZeitplanungsvorlagenForTableView');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageTableDTOs>({
            url: '/zeitplanungsvorlage/zeitplanungsvorlagen/tabellenansicht/{isFilterNeeded}'.replace('{isFilterNeeded}', encodeURI(isFilterNeeded)),
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Kommentare einer Zeitplanung
     * GET KOMMENTARE
     */
    getZpvKommentare({ zeitplanungsvorlageId }: GetZpvKommentareRequest): Observable<ZeitplanungsvorlageKommentarEntityListResponseDTO>
    getZpvKommentare({ zeitplanungsvorlageId }: GetZpvKommentareRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageKommentarEntityListResponseDTO>>
    getZpvKommentare({ zeitplanungsvorlageId }: GetZpvKommentareRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageKommentarEntityListResponseDTO | AjaxResponse<ZeitplanungsvorlageKommentarEntityListResponseDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlageId, 'zeitplanungsvorlageId', 'getZpvKommentare');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageKommentarEntityListResponseDTO>({
            url: '/zeitplanungsvorlage/kommentare/{zeitplanungsvorlageId}'.replace('{zeitplanungsvorlageId}', encodeURI(zeitplanungsvorlageId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert einen Termin
     * PUT ZEITPLANUNGSVORLAGE DATE
     */
    modifyDateInZeitplanungsvorlage({ elementId, terminvorlageEntityDTO }: ModifyDateInZeitplanungsvorlageRequest): Observable<void>
    modifyDateInZeitplanungsvorlage({ elementId, terminvorlageEntityDTO }: ModifyDateInZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyDateInZeitplanungsvorlage({ elementId, terminvorlageEntityDTO }: ModifyDateInZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyDateInZeitplanungsvorlage');
        throwIfNullOrUndefined(terminvorlageEntityDTO, 'terminvorlageEntityDTO', 'modifyDateInZeitplanungsvorlage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/date/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: terminvorlageEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert eine Phase
     * PUT ZEITPLANUNGSVORLAGE PHASE
     */
    modifyPhaseInZeitplanungsvorlage({ elementId, phasenvorlageEntityDTO }: ModifyPhaseInZeitplanungsvorlageRequest): Observable<void>
    modifyPhaseInZeitplanungsvorlage({ elementId, phasenvorlageEntityDTO }: ModifyPhaseInZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyPhaseInZeitplanungsvorlage({ elementId, phasenvorlageEntityDTO }: ModifyPhaseInZeitplanungsvorlageRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyPhaseInZeitplanungsvorlage');
        throwIfNullOrUndefined(phasenvorlageEntityDTO, 'phasenvorlageEntityDTO', 'modifyPhaseInZeitplanungsvorlage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/phase/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: phasenvorlageEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert einen Kommentar
     * PUT KOMMENTAR
     */
    modifyZpvKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpvKommentarRequest): Observable<void>
    modifyZpvKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyZpvKommentar({ kommentarId, zeitplanungKommentarModifyRequestDTO }: ModifyZpvKommentarRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(kommentarId, 'kommentarId', 'modifyZpvKommentar');
        throwIfNullOrUndefined(zeitplanungKommentarModifyRequestDTO, 'zeitplanungKommentarModifyRequestDTO', 'modifyZpvKommentar');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/zeitplanungsvorlage/kommentar/{kommentarId}'.replace('{kommentarId}', encodeURI(kommentarId)),
            method: 'PUT',
            headers,
            body: zeitplanungKommentarModifyRequestDTO,
        }, opts?.responseOpts);
    };

}
